/****************************************************************
 * SMT Hight-Low mode ŁAԊOR̃pXusPʂ
 * 肵AEUSARTUSBϊoRPCɑM
 * LCD(AQM1602Y)ɂ\
 ****************************************************************/

#include "mcc_generated_files/mcc.h"
#include "i2cLCD_ST7032i.h"

#define maxdata 75                                  	// ԊOf[^[z

uint16_t PW[maxdata];                               	// Markz
int16_t  PR[maxdata];                               	// Spacez
uint8_t  p_PW;                                      	// Markz|C^
uint8_t  p_PR;                                      	// Spacez|C^

uint8_t  Sony;                                      	// SonytH[}bgH
char     sBf[20];                                  		// ƃGA

void prt_Hex(uint8_t w, uint8_t n){                 	// 16i\
    if(n){
        sprintf(sBf,"%02X ",w);
        printf("  >> %02XH\n\r",w);
    }else{
        sprintf(sBf,"%02X",w);
        printf("  >> %02XH",w);  
    }
    LCD_str(sBf);                                   	// LCD\
 }

/*=====  Main application  ===== */
void main(void)
{
    uint8_t ird;                                        // ԊOf[^
    uint8_t sbt;                                        // rbgZbgpVtgoCg
    uint8_t bct;                                        // Lrbgf[^JE^
    uint8_t sgf;

    SYSTEM_Initialize();                                // foCX
    LCD_init();

    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    LCD_str("ready");  
    
    while (1)                                           // ԊOMM@JԂ
    {
        p_PW = 0;                                       // f[^|C^
        p_PR = 0;
        SMT1PWAIF = 0;                                  // tONA
        SMT1PRAIF = 0;
        SMT1IF = 0;
        SMT1CON1bits.SMT1GO = 1;                        // Jn
        printf("\r\nready\r\n");                        // bZ[WM
        
        // ---------- ԊOMM --------
        while((p_PR < maxdata)){                        // obt@t܂ŌJ
            if(SMT1PWAIF){                              // markIȂ
                SMT1PWAIF = 0;                          // tONA
                PW[p_PW++]=SMT1CPW;                     // HighԂۑ
            }
            if(SMT1PRAIF){                              // spaceIȂ
                SMT1PRAIF = 0;                          // tONA
                if(SMT1CPR < 10000){                    // 10msȂ
                    PR[p_PR++]=SMT1CPR;                 //   ̂܂LowԂۑ
                }else{                                  // 10msȏȂ
                    PR[p_PR++]=-(SMT1CPR / 1000);       //   msɕϊŕۑ
                }
            }
            if(SMT1IF){                                 // M100ms
                SMT1IF = 0;                             // tONA
                PR[p_PR++]=0;                           // MLu0vۑ
                break;
            }
        }
        SMT1CON1bits.SMT1GO = 0;                        // I

        //----------@Mʂ́EM -------
        ird = 0;
        sbt = 1;
        bct = 0;
        sgf = 0;

        LCD_clr();
        if(PW[0]<3000){
            Sony = 7;                                   // -> SONY Mode
            IO_RC2_SetHigh();
			sprintf(sBf,">SONY, %d",p_PW);
			LCD_str(sBf);
			puts(sBf);
        }else{
            Sony = 0;                                   // -> NEC Mode
            IO_RC2_SetLow();
			sprintf(sBf,">NEC, %d",p_PW);
			LCD_str(sBf);
			puts(sBf);
        }

        printf(" -  mark  space (us)\r\n");             // ^CgM
        LCD_cursor(0,1);
        for(char i=0;i<p_PW;i++){                       // ۑԂ𑗐M
            printf("%2d %5d",i,(uint16_t)PW[i]);        // mark
            if(PR[i]==0) {                              // MȂ
                printf("    ---");                      //  u---v𑗐M
                if(Sony){
                    if(PW[i] < 1600){               	// mark1600usȂ
                        bct++;
                        if(PW[i] > 900){            	// mark900usȂ
                            ird |= sbt;             	// VtgoCg
                            printf("  1");
                        }else{
                            printf("  0");
                        }
                        prt_Hex(ird, 0);            	// 16iŕ\
                    }
                }                           
            }else if(PR[i] > 0){                        // 10msȂ
                printf("  %5d",PR[i]);                  //   usPʂőM(sOj
                if (Sony){                              // *== SONY Code (Mark) ==
                    if(PW[i] < 1600){                   // mark1500usȂ
                        sgf = 1;                        // Lf[^
                        if(PW[i] > 900){                // mark900usȂ
                            ird |= sbt;                 // VtgoCg
                            printf("  1");
                        }else{
                            printf("  0");
                        }
                    }
                }else{                                  // *== NEC Code (Space) ==
                    if(PW[i] < 1500){                   // mark1500Ȃ
                        if(PR[i]<2000){                 // space2000Ȃ
                            sgf = 1;                    // Lf[^
                            if(PR[i]>900){              // space900ȏȂ
                                ird |= sbt;             // VtgoCg
                                printf("  1");
                            }else{
                                printf("  0");
                            }
                        }
                    }
                }
                if(sgf){                                // Lf[^Ȃ 
                    sbt <<= 1;                          // VtgoCgփVtg
                    bct++;                              // Lf[^1₷
                    if(Sony){                           // R[hSONYȂ
                        if(bct == Sony){
							prt_Hex(ird, 0);            // 16iőM(\j
                            ird = 0;                    // ԊOf[^NA 
                            sbt = 1;                    // VtgoCg  
                            Sony = bct + 8;
                        }
                    }else{                              // R[hSONYȊOiNEC)
                        if((bct % 8) == 0){             // f[^8̔{Ȃ
							prt_Hex(ird, 0);            // 16iőM(\j
                            ird = 0;                    // ԊOf[^NA 
                            sbt = 1;                    // VtgoCg  
                        }
                    }
                    sgf = 0;
                }
            }else{                                      // 10msȂ
                printf("%5d (ms)",-PR[i]);              //   msPʂőM
                 if(Sony){
                    if(PW[i] < 1600){                   // mark1500usȂ
                        bct++;
                        if(PW[i] > 900){                // mark900usȂ
                            ird |= sbt;                 // VtgoCg
                            printf("  1");
                        }else{
                            printf("  0");
                        }
						prt_Hex(ird, 1);                // 16iőM(\j
                        ird = 0;                        // ԊOf[^NA 
                        sbt = 1;                        // VtgoCg 
                        Sony = bct + 7;
                    }               
                 }
            }
            printf("\r\n");
        }

        if(p_PW >= maxdata){                            // obt@tȂ
            printf("-- Buffer Full --\r\n");            //  Buffer Full M
        }
    }
}

/*****   End of File   *****/
